program mysqladmin; {$PMType VIO}
(* Copyright Abandoned 1996 TCX DataKonsult AB & Monty Program KB & Detron HB
   This file is public domain and comes with NO WARRANTY of any kind *)
uses Use32, libMySQL, sysMySQL, Strings, SysUtils, NetLib;
(* maintaince of mysql databases *)

const
  ADMIN_VERSION 	= '6.9';

const
  interval		: Integer	= 0;
  option_quick		: Boolean	= False;
  interrupted		: Boolean	= False;
  new_line		: Boolean	= False;
  option_silent 	: Boolean	= False;

type
  tscore		= (scoretop, scorehdr, scoremid, scorebot);

procedure print_version; forward;
procedure usage; forward;
//function  execute_commands(mysql:PMYSQL;args:array of const):Boolean; forward;
//static sig_handler endprog(int signal_number);
function  create_db(mysql:PMYSQL;db:PChar):Integer; forward;
function  drop_db(mysql:PMYSQL;db:PChar):Integer; forward;
procedure nice_time(sec:Cardinal;buff:PChar); forward;
procedure print_header(result:PMYSQL_RES); forward;
procedure print_top(result:PMYSQL_RES;scoretype:tscore); forward;
//procedure print_top(result:PMYSQL_RES;score:Char); forward;
procedure print_row(result:PMYSQL_RES;cur:PMYSQL_ROW); forward;


procedure main;
var
  host, password, user	: PChar;
  stat, pos		: PChar;
  mysql 		: libMySQL.MYSQL;
  buff			: Array[0..39] of Char;
  error 		: Boolean;
  sec			: Cardinal;
  result		: PMYSQL_RES;
  row			: PMYSQL_ROW;
begin
  host := nil; password := nil; user := nil;
  error := False;

  host := '192.168.166.210';

  if mysql_connect(@mysql,host,user,password) = nil then begin
    error := true;
    if not option_silent then begin
      if host = nil then host := LOCAL_HOST;
      {my_printf_error(0,"connect to server at '%s' failed\nerror: '%s'",
		      MYF(ME_BELL), host, mysql_error(&mysql));}
      Writeln(Format('connect to server at ''%s'' failed'#7#13#10'error: ''%s''',[host, mysql_error(@mysql)]));
      if mysql_errno(@mysql) = CR_CONNECTION_ERROR then begin
	write(Format('Check that mysqld is running and that the socket: ''%s'' exists!'#13#10,[mysql_unix_port]));
      end else
      if (mysql_errno(@mysql) = CR_CONN_HOST_ERROR) or
	 (mysql_errno(@mysql) = CR_UNKNOWN_HOST) then begin
	write(Format('Check that mysqld is running on %s and that the port is %d.'#13#10'You can check this by doing ''telnet %s %d'''#13#10,
		[host, mysql_port, host, mysql_port]));
      end;
    end
  end else begin
    error := false;

    print_version;
    writeln('TCX Datakonsult AB, by Monty'#13#10);
    stat := StrNew(getinetversion); if stat=nil then stat := getinetversion; if stat=nil then stat := 'unknown';
    write(Format('Server version'#9#9'%s'#13#10, [mysql_get_server_info(@mysql)]));
    write(Format('Protocol version'#9'%d'#13#10, [mysql_get_proto_info(@mysql)]));
    write(Format('TCP/IP version'#9#9'%s'#13#10,[stat]));
    write(Format('Connection'#9#9'%s'#13#10,[mysql_get_host_info(@mysql)]));
    if mysql.unix_socket <> nil then
      write(Format('UNIX socket'#9#9'%s'#13#10, [mysql.unix_socket]))
    else
      write(Format('TCP port'#9#9'%d'#13#10, [mysql.port]));
    stat := mysql_stat(@mysql);
    pos := StrScan(stat,' ');
    pos^ := #0; inc(pos);
    write(stat,#9#9#9); 		      (* print label *)
    stat := str2int(pos,10,0,High(Cardinal),LongInt(sec));
    if stat<>nil then begin
      nice_time(sec,buff);
      Writeln(PChar(@buff));		      (* print nice time *)
      while stat^ = ' ' do inc(stat);         (* to next info *)
    end;
    writeln;
    if stat<>nil then writeln(stat);

    result := mysql_list_processes(@mysql);
    if result=nil then begin
      writeln(Format('process list failed; error: ''%s'''#7#13#10,[mysql_error(@mysql)]));
    end else begin
      print_header(result);
      row := mysql_fetch_row(result);
      while row <> nil do begin
	print_row(result,row);
	row := mysql_fetch_row(result);
      end;
      print_top(result,scorebot);
      mysql_free_result(result);
    end;

    mysql_close(@mysql);
  end;
  //my_free(password,MYF(MY_ALLOW_ZERO_PTR));
  //my_end(0);
  //Halt(error);
end;


procedure print_version;
begin
  Write(Format('%s  Ver %s Distrib %s, for %s on %s'#13#10,[ParamStr(0),ADMIN_VERSION,
	 MYSQL_SERVER_VERSION,SYSTEM_TYPE,MACHINE_TYPE]));
end;

procedure usage;
begin
  print_version;
  writeln('TCX Datakonsult AB, by Monty');
  writeln('This software comes with NO WARRANTY: see the file PUBLIC for details.'#13#10);
  writeln('Administer program for the mysqld demon (PASCAL VERSION)');
  write(Format('Usage: %s [OPTIONS] command command....'#13#10,[ParamStr(0)]));
  write(PChar(#13#10+
	'  -#, --debug=...       Output debug log. Often this is ''d:t:o,filename`'#13#10+
	'  -f, --force           Don''t ask for confirmation on drop table. Continue'#13#10+
	'                        even if we get an error'#13#10+
	'  -?, --help            Display this help and exit'#13#10+
	'  -h, --host=#          Connect to host'#13#10+
	'  -p, --password[=...]  Password to use when connecting to server'#13#10+
	'                        If password is not given it''s asked from the tty.'#13#10+
	'  -P  --port=...        Port number to use for connection'#13#10+
	'  -i, --sleep=sec       Execute commands again and again with a sleep between'#13#10+
	'  -s, --silent          Silently exit if one can''t connect to server'#13#10+
	'  -S  --socket=...      Socket file to use for connection'#13#10));
  write('  -u, --user=#          User for login if not current user'#13#10);
  write('  -V, --version         Output version information and exit'#13#10);

  writeln(PChar(#13#10'Where command is a one or more of: (Commands may be shortened)'#13#10+
	'  create databasename   Create a new database'#13#10+
	'  drop databasename     Delete a database and all its tables'#13#10+
	'  flush-hosts           Flush all cached hosts'#13#10+
	'  flush-logs            Flush all logs'#13#10+
	'  flush-tables          Flush all tables'#13#10+
	'  kill id,id,...        Kill mysql threads'#13#10+
	'  password new-password Change old password to new-password'#13#10+
	'  processlist           Show list of active threads in server'#13#10+
	'  reload                Reload grant tables'#13#10+
	'  refresh               Flush all tables and close and open logfiles'#13#10+
	'  shutdown              Take server down'#13#10+
	'  status                Gives a short status message from the server'#13#10+
	'  variables             Prints variables available'#13#10+
	'  version               Get version info from server'#13#10));
end;


function create_db(mysql:PMYSQL;db:PChar):Integer;
begin
  if mysql_create_db(mysql,db)<>0 then begin
    {my_printf_error(0,"create of '%s' failed\nerror: '%s'",MYF(ME_BELL),
		    db,mysql_error(mysql));}
    write(Format('create of ''%s'' failed'#7#13#10'error: ''%s'''#13#10,[db,mysql_error(mysql)]));
    Result := 1;
    exit;
  end;
  write(Format('Database "%s" created.'#13#10,[db]));
  Result := 0;
end;


function drop_db(mysql:PMYSQL;db:PChar):Integer;
var
  ch			: Char;
  ln			: String;
begin
  if not option_quick then begin
    writeln('Dropping the database is potentially a very bad thing to do.');
    writeln('Any data stored in the database will be destroyed.'#13#10);
    write(Format('Do you really want to drop the ''%s'' database [y/N]',[db]));
    ReadLn(ln);
    if UpCase(ln[1])<>'Y' then begin
      writeln(#13#10'OK, aborting database drop!');
      Result := -1;
      exit;
    end;
  end;
  if mysql_drop_db(mysql,db)<>0 then begin
    {my_printf_error(0,"drop of '%s' failed;\nerror: '%s'",MYF(ME_BELL),
		    db,mysql_error(mysql));}
    writeln(Format('drop of ''%s'' failed;'#7#13#10'error: ''%s''',[db,mysql_error(mysql)]));
    Result := 1;
    exit;
  end;
  write(Format('Database "%s" dropped'#13#10,[db]));
  Result := 0;
end;


procedure nice_time(sec:Cardinal;buff:PChar);
var
  tmp			: Cardinal;
begin
  if sec >= 3600*24 then begin
    tmp := sec div (3600*24);
    dec(sec,3600*24*tmp);
    buff := int2str(tmp,buff,10);
    if tmp>1 then
      buff := StrECopy(buff,' days ')
    else
      buff := StrECopy(buff,' day ');
  end;
  if sec >= 3600 then begin
    tmp := sec div 3600;
    dec(sec,3600*tmp);
    buff := int2str(tmp,buff,10);
    if tmp>1 then
      buff := StrECopy(buff,' hours ')
    else
      buff := StrECopy(buff,' hour ');
  end;
  if sec >= 60 then begin
    tmp := sec div 60;
    dec(sec,60*tmp);
    buff := int2str(tmp,buff,10);
    buff := StrECopy(buff,' min ');
  end;
  StrCopy(int2str(sec,buff,10),' sec');
end;

procedure print_header(result:PMYSQL_RES);
var
  lnbuf 		: Array[0..1024] of Char;
  pos			: PChar;
  field 		: PMYSQL_FIELD;
begin
  FillChar(lnbuf,Sizeof(lnbuf),0);
  pos := StrECopy(lnbuf,'');
  print_top(result,scoretop);
  mysql_field_seek(result,0);
  field := mysql_fetch_field(result);
  while field<>nil do begin
    FillChar(pos^,field^.max_length+2,32);inc(pos);
    StrECopy(pos,field^.fname)^ := ' '; inc(pos);
    inc(pos,field^.max_length);
    pos^ := #186; inc(pos);
    field := mysql_fetch_field(result);
  end;
  writeln(lnbuf);
  print_top(result,scorehdr);
end;


procedure print_top(result:PMYSQL_RES;scoretype:tscore);
var
  lnbuf 		: Array[0..1024] of Char;
  score 		: Char;
  pos			: PChar;
  i,length		: Word;
  field 		: PMYSQL_FIELD;
begin
  FillChar(lnbuf,Sizeof(lnbuf),0);
  case scoretype of
    scoretop	 : begin pos := StrECopy(lnbuf,''); score := #205 end;
    scorehdr	 : begin pos := StrECopy(lnbuf,''); score := #205 end;
    scoremid	 : begin pos := StrECopy(lnbuf,''); score := #196 end;
    scorebot	 : begin pos := StrECopy(lnbuf,''); score := #205 end;
  end;
  mysql_field_seek(result,0);
  field := mysql_fetch_field(result);
  while field<>nil do begin
    length := StrLen(field^.fname);
    if length>field^.max_length then
      field^.max_length := length
    else
      length:=field^.max_length;
    FillChar(pos^,length+2,score); inc(pos,length+2);
    field := mysql_fetch_field(result);
    case scoretype of
      scoretop	   : if field = nil then pos^ := #187 else pos^ := #203;
      scorehdr	   : if field = nil then pos^ := #185 else pos^ := #206;
      scoremid	   : if field = nil then pos^ := #185 else pos^ := #197;
      scorebot	   : if field = nil then pos^ := #188 else pos^ := #202;
    end;
    inc(pos);
  end;
  writeln(lnbuf);
end;


procedure print_row(result:PMYSQL_RES;cur:PMYSQL_ROW);
var
  lnbuf 		: Array[0..1024] of Char;
  pos			: PChar;
  i, length, l		: Word;
  field 		: PMYSQL_FIELD;
begin
  FillChar(lnbuf,Sizeof(lnbuf),0);
  pos := StrECopy(lnbuf,'');
  //write('|');
  mysql_field_seek(result,0);
  l := mysql_num_fields(result)-1;
  for i := 0 to l do begin
    field := mysql_fetch_field(result);
    length := field^.max_length;
    fillChar(pos^,length+2,32);inc(pos);
    if cur^[i]<>nil then StrECopy(pos,cur^[i])^:=' ';
    inc(pos,length+1);
    if i=l then pos^:=#186 else pos^:='|';
    inc(pos);
  end;
  writeln(lnbuf);
end;

begin
  main;
end.
